<script setup>
import {useRoute} from "vue-router"
import {computed, ref, watch} from "vue"
import {useLessonStore} from "@/stores/lesson"
import Sidebar from "@/components/Sidebar.vue"
import {useRoomStore} from "@/stores/room";
import {router} from "@/router";
import {useTrainerStore} from "@/stores/trainer";
import {useGroupStore} from "@/stores/group";
import {useEnumStore} from "@/stores/enumStore";

const route = useRoute()
const lessonStore = useLessonStore()
const trainerStore = useTrainerStore()
const groupStore = useGroupStore()
const roomStore = useRoomStore()


const trainerId = ref()
const groupId = ref()
const subjects = ref([])
const roomId = ref()
const weekday = ref([])
const apiError = ref("")

const edit = ref(false)


const enumStore = useEnumStore()


const lessonIndex = computed(() => parseInt(route.params.lessonIndex))
const lessonget = computed(() => lessonStore.lessons[lessonIndex.value])

const lesson = ref()
const trainer = ref()
const subjectList = computed(() => enumStore.subjects.filter(subject => trainerStore.trainers.find(trainer => trainer.id === lesson.value.trainerId)?.subjects.includes(subject)))

watch(lessonget, () => lesson.value = ({...lessonget.value} || {TrainerId: ""}), {immediate: true})

async function deleteLesson() {
  const response = await useLessonStore().deleteLesson(lesson.value);

  await router.push("/lesson")
  console.log("test");
}

async function updateLesson() {

  apiError.value = ""

  try {
    await lessonStore.updateLesson(lesson.value)

  } catch (err) {
    if (err.isAxiosError && err.status === 401) {
      apiError.value = "You must be logged in"
    } else {
      apiError.value = "Unknown error"
    }
  }
  await router.push("/lesson")

  trainerId.value = null
  groupId.value = null
  subjects.value = []
  roomId.value = null
  weekday.value = []
}

</script>

<template>
  <Sidebar></Sidebar>

  <h1>Details for Lessons</h1>

  <div class="container text-white rounded-2 p-3 mb-3">
    <p>Trainer:
      <span v-if="!edit"> {{ trainerStore.trainers.find(trainer => trainer.id === lesson.trainerId)?.firstName }}
    {{ trainerStore.trainers.find(trainer => trainer.id === lesson.trainerId)?.lastName }}</span>
      <select v-else class="form-select" name="room" v-model="lesson.trainerId">
        <option v-for="trainer in trainerStore.trainers" :value="trainer.id">{{ trainer.firstName }}
          {{ trainer.lastName }}
        </option>
      </select>
    </p>

    <p>Group:
      <span v-if="!edit">{{ groupStore.groups.find(group => group.groupId === lesson.groupId)?.specializations }}
    {{ groupStore.groups.find(group => group.groupId === lesson.groupId)?.groupNumber }}</span>
      <select v-else class="form-select group" name="groupId" v-model="lesson.groupId">
        <option v-for="group in groupStore.groups" :value="group.groupId">{{ group.specializations }}
          {{ group.groupNumber }}
        </option>
      </select>
    </p>

    <p>Subjects: <span v-if="!edit">{{ lesson.subjects }}</span>
      <select v-else class="form-select subjects" v-model="lesson.subjects">
        <option v-for="sub in subjectList">{{ sub }}</option>
      </select></p>

    <p>Room:
    </p>
    <p>
      {{ roomStore.rooms.find(room => room.roomId === groupStore.groups.find(group => group.groupId === lesson.groupId)?.roomId)?.roomNumber }}
      {{ roomStore.rooms.find(room => room.roomId === groupStore.groups.find(group => group.groupId === lesson.groupId)?.roomId)?.vip }}</p>

    <p>Weekdays: <span v-if="!edit">{{ lesson.weekday }}</span>
      <select v-else class="form-select" v-model="lesson.weekday">
        <option v-for="day in enumStore.weekdays">{{ day }}</option>
      </select></p>
  </div>

  <div class="buttons">
    <v-btn type="submit" class="btn btn-warning mx-2" @click="edit = !edit" v-if="!edit">Edit</v-btn>
    <v-btn type="submit" class="btn btn-warning mx-2" @click="updateLesson" v-else>Save</v-btn>
    <v-btn type="submit" class="btn btn-danger" @click="deleteLesson">Delete</v-btn>
  </div>

</template>

<style scoped>
h1 {
  margin-left: 0px;
  margin-bottom: 20px;
  margin-top: 0px;
}

p {
  margin-left: 0px;
}

.form-check {
  margin-left: 0px;
}

.container {
  background-color: black;
  width: 1000px;
}

.buttons {
  margin-left: 0px;
  margin-top: 15px;
  margin-bottom: 20px;

}

</style>